#include "assoc.h"

QString assocNames[LAST_ASSOC] = {
    "Verboten", "Erlaubt",
    "Statprereq", "Lernprereq", "Gruppeprereq",
    "Typisch", "Gruppe",
    "LE-Kosten", "TE-Kosten"
};

int findName(const QString& name, const QString* names, int max) {
    for(int i = 0; i < max; i++)
        if (names[i] == name)
            return i;
    return max;
}

void Assoc::write(EvaXmlDoc& doc, QDomElement& parent) {
    QDomElement ae = doc.createElement("Assoc");
    ae.setAttribute("typ", assocNames[typ]);
    ae.setAttribute("sWert", sWert);
    ae.setAttribute("iWert", i2s(iWert));
    parent.appendChild(ae);
}

bool Assoc::read(const QDomElement& de) {
    QString t = de.attribute("typ");
    typ   = AssocTypen(findName(t, assocNames, LAST_ASSOC));
    sWert = de.attribute("sWert");
    iWert = de.attribute("iWert").toInt();
    return typ < LAST_ASSOC;
}

bool Assoc::operator==(const Assoc& b) const {
    return typ == b.typ && sWert  == b.sWert && iWert == b.iWert;
}

AssocList AssocList::assocs(AssocTypen typ) const {
    AssocList ret;
    foreach(Assoc a, *this) {
        if (a.typ == typ)
            ret.append(a);
    }
    return ret;
}

void AssocList::addGruppe(const Assoc& a) {
    // hier werden die Gruppen sortiert, so dass sie in den Neu(4,5)-Dialogen in der richtigen
    // Reihenfolge erscheinen. Zauber und Waffen am Schluss, die anderern alphabetisch.
    // "Alltag" muss die erste sein, dafuer wird in Figur::fGruppenList gesorgt
    int i;
    for(i = 0; i < length(); i++) {
        if (at(i).sWert == a.sWert)
            return;
        if (at(i).sWert > a.sWert)
            break;
    }
    if (a.typ == GRUPPE)
        append(a);
    else
        insert(i, a);
}
