#include "dlggradneu.h"

DlgGradNeu::DlgGradNeu(Figur* f, QWidget *parent)
    : QDialog(parent)
{
    figur = f;
    ui.setupUi(this);
    ui.header->setText("Neuer Grad " + i2s(figur->grad()) + " erreicht!");
    on_reroll_clicked();
}

void DlgGradNeu::on_reroll_clicked() {
    ui.ap->setText(i2s(roll(1,3)));
    ui.w100->setText(i2s(roll(1, 100)));
}

void DlgGradNeu::on_w100_textChanged(const QString s) {
    int     w   = s.toInt();    // der W%-Wurf
    QString res = "";           // die dazugehoerige Eigenschaft

         if (w <  51) res = "Keine Verbesserung";
    else if (w <  56) res = "Willenskraft";
    else if (w <  61) res = "Ausstrahlung";
    else if (w <  66) res = "Aussehen";
    else if (w <  71) res = fl("Strke");
    else if (w <  76) res = "Geschicklichkeit";
    else if (w <  81) res = "Gewandheit";
    else if (w <  86) res = "Konstitution";
    else if (w <  91) res = "Intelligenz";
    else if (w <  96) res = "Zaubertalent";
    else              res = "freie Wahl";
    ui.eigenschaft->setText(res);
    if (w > 50) {
        ui.w3p1->setText(i2s(roll(1,3) + 1));
        ui.w3p1->setEnabled(true);
    } else {
        ui.w3p1->setText("");
        ui.w3p1->setEnabled(false);
    }
}
