#include "dlgoptionen.h"

QStringList     checkBoxes = QStringList() << "QCheckBox" << "QRadioButton" << "QGroupBox";

void saveState(QWidget* w, QString prefix) {
    QSettings settings;

    if (w == NULL)
        return;
    prefix = w->objectName();
    if (prefix.length() > 0) {
        QAbstractButton* ab = qobject_cast<QAbstractButton*>(w);
        if (ab != NULL)
            settings.setValue(prefix, ab->isChecked());
        QGroupBox* gb = qobject_cast<QGroupBox*>(w);
        if (gb != NULL)
            settings.setValue(prefix, gb->isChecked());
    }
    foreach(QObject* child, w->children()) {
        QWidget* w = qobject_cast<QWidget*>(child);
        saveState(w, prefix);
    }
}

void readState(QWidget* w, QString prefix) {
    QSettings settings;

    if (w == NULL)
        return;
    prefix = w->objectName();
    if (prefix.length() > 0) {
        QAbstractButton* ab = qobject_cast<QAbstractButton*>(w);
        if (ab != NULL)
            ab->setChecked(settings.value(prefix, true).toBool());
        QGroupBox* gb = qobject_cast<QGroupBox*>(w);
        if (gb != NULL)
            gb->setChecked(settings.value(prefix, true).toBool());
    }
    foreach(QObject* child, w->children())
        readState(qobject_cast<QWidget*>(child), prefix);
}

DlgOptionen::DlgOptionen(int numSaetze, QWidget *parent)
    : QDialog(parent)
{
    setupUi(this);
    satz->setMaximum(numSaetze);
    satz->setMinimum(1);
    satz->setValue(settings.value("BogenSatz", 1).toInt());
    readState(this, "");
}

void DlgOptionen::accept() {

    settings.setValue("BogenSatz", satz->value());
    saveState(this, "");
    QDialog::accept();
}

DlgOptionen::~DlgOptionen()
{
}
