#ifndef EVA_H
#define EVA_H

/* 
    EVA ist die Klasse fuer die Hauptfenster incl. Menu und Toolbar
*/

#include <QtGui>
#include "ui_eva.h"

#include "boegen.h"

class EVA : public QMainWindow
{
    Q_OBJECT

public:
    EVA(QString fname = "");
    ~EVA();

private:
    Ui::EVAClass        ui;

    QSettings           settings;   // Persistente Konfigurations-Einstellungen (Menuepunkt "Optionen")
    Figur*              figur;      // Figur die in diesem Fenster angezeigt wird
    QList<Bogen*>       boegen;     // Verwaltung der Boegen(-Widgets)
    int                 actSatz;    // Satz des aktuell angezeigten Figurenbogens
    int                 actBogen;
    QActionGroup*       agBoegen;
    QAction*            boegenSep;  // Separator nach den Boegen-Icons

    void enableActions();           // abhaengig von der Figur Menuoptionen disabeln
    void showDialog(QDialog *d, bool doRedraw);

private slots:
    void PPchanged();               // PP veraendert
    void redraw();                  // Bogen neu zeichnen, ggf. vorher wechseln

    // Datei
    void on_actionNeu_triggered();
    void on_actionOeffnen_triggered();
    void on_actionSpeichern_triggered();
    void on_actionDrucken_triggered();
    void on_actionOptionen_triggered();
    void on_actionQuit_triggered();

    // Lernen
    void on_actionEP_vergeben_triggered();
    void on_actionFertigkeiten_triggered();
    void on_actionWaffen_triggered();
    void on_actionZauber_triggered();
    void on_actionStat_Editor_triggered();

    // Ausruestung
    void on_actionGepaeck_triggered();
    void on_actionStandard_Ausstattung_triggered();
    void on_actionDatenbank_triggered();

    // Hilfe
    void on_actionAbout_triggered();
};

#endif // EVA_H
