#include "neuwizard.h"
#include "neu1rasse.h"

#include "lernstoff.h"

QStringList raceOrder = QStringList() << "Mensch" << "Elf" << "Halbling" << "Zwerg";

bool isRaceLess(const Lernstoff* l1, const Lernstoff* l2) {
    foreach(QString s, raceOrder) {
        if (l1->name().contains(s)) return true;
        if (l2->name().contains(s)) return false;
    }
    return l1->name() < l2->name();
}

Neu1Rasse::Neu1Rasse(QWidget *parent)
    : QWizardPage(parent)
{
    setupUi(this);
    LernList ll = Stoffe::l(RASSE);
    qSort(ll.begin(), ll.end(), isRaceLess);
    foreach(const Lernstoff* l, ll)
        rasse->addItem(l->name());
    ll = Stoffe::l(LAND);
    ll.sort(LES_LAENDER);
    foreach(const Lernstoff* l, ll)
        gastland->addItem(l->name());
    fw = new Bogen(this);
}

Neu1Rasse::~Neu1Rasse()
{
}

void Neu1Rasse::getValues() {
    FIGUR->setWidgetValue("name",             name->text());
    FIGUR->setWidgetValue("spieler",          spieler->text());
    FIGUR->setWidgetValue("frau",             weiblich->isChecked());
    FIGUR->setWidgetValue("gastland",         gastland->currentText());
    FIGUR->setWidgetValue("rasse",            rasse->currentText());
    FIGUR->setWidgetValue("herkunft",         herkunft->currentText());
    FIGUR->setWidgetValue("staerke",          staerke->text());
    FIGUR->setWidgetValue("geschicklichkeit", geschicklichkeit->text());
    FIGUR->setWidgetValue("gewandheit",       gewandheit->text());
    FIGUR->setWidgetValue("konstitution",     konstitution->text());
    FIGUR->setWidgetValue("intelligenz",      intelligenz->text());
    FIGUR->setWidgetValue("zaubertalent",     zaubertalent->text());
}


bool Neu1Rasse::validatePage() {
    getValues();
    return QWizardPage::validatePage();
}

void Neu1Rasse::on_reroll_clicked() {
    getValues();
    FIGUR->rollBaseStats();
    fw->update(FIGUR);
}

void Neu1Rasse::initializePage() {
    QWizardPage::initializePage();
    on_rasse_currentIndexChanged();
}

void Neu1Rasse::on_rasse_currentIndexChanged() {
    if (wizard() == NULL)
        return;
    FIGUR->lerne(rasse->currentText());
    LernList ll = FIGUR->lernbar(LAND, LK_NONE);
    ll.sort(LES_LAENDER);
    herkunft->clear();
    foreach(const Lernstoff* l, ll)
        herkunft->addItem(l->name());
    on_reroll_clicked();
}