#include "neu2typ.h"

#include "neuwizard.h"

Neu2Typ::Neu2Typ(QWidget *parent)
    : QWizardPage(parent)
{
    setupUi(this);
    haendig->addItem(fl("rechtshndig"));
    haendig->addItem(fl("linkshndig"));
    haendig->addItem(fl("beidhndig"));
    fw = new Bogen(this);
}

void Neu2Typ::initializePage() {
    QWizardPage::initializePage();
    fw->update(FIGUR);
    on_reroll_clicked();
}

bool Neu2Typ::validatePage() {
    FIGUR->setWidgetValue("groesse",            groesse->text());
    FIGUR->setWidgetValue("gewicht",            gewicht->text());
    FIGUR->setWidgetValue("aussehen",           aussehen->text());
    FIGUR->setWidgetValue("ausstrahlung",       ausstrahlung->text());
    FIGUR->setWidgetValue("bewegungsweite",     bewegungsweite->text());
    FIGUR->setWidgetValue("willenskraft",       willenskraft->text());
    FIGUR->setWidgetValue("haendig",            haendig->currentText());
    FIGUR->setWidgetValue("klasse",             klasse->currentText());
    FIGUR->setWidgetValue("alter",              alter->text());
    return QWizardPage::validatePage();
}

void Neu2Typ::on_reroll_clicked() {
    FIGUR->rollDerivedStats();
    fw->update(FIGUR);
    for (int i = 0; i < haendig->count(); i++)
        if (haendig->itemText(i) == FIGUR->haendig())
            haendig->setCurrentIndex(i);
}

void Neu2Typ::on_gewicht_textChanged() {
    if (gewicht->text() == "")
        return;
    FIGUR->setGewicht(gewicht->text().toInt());
    gestalt->setText(FIGUR->gestalt());
}

void Neu2Typ::on_groesse_textChanged() {
    if (groesse->text() == "")
        return;
    FIGUR->setGroesse(groesse->text().toInt());
    gestalt->setText(FIGUR->gestalt());
}

void Neu2Typ::on_ausstrahlung_textChanged() {

    FIGUR->setAusstrahlung(ausstrahlung->text().toInt());
    LernList klassen = FIGUR->lernbar(KLASSE, LK_NONE);
    klassen.sort(LES_KLASSEN);
    QString actKlasse = klasse->currentText();
    klasse->clear();
    foreach(const Lernstoff* l, klassen) {
        Klasse* k = (Klasse*)l;
        if (QSettings().value("eigenschaften", true).toBool() && !FIGUR->lernbar(k, LK_NONE))
          continue;
        klasse->addItem(k->name_mw(FIGUR->frau()));
    }
    int i = klasse->findText(actKlasse);
    if (i >= 0)
        klasse->setCurrentIndex(i);
}
