#include "neu6dinge.h"
#include "neuwizard.h"
#include "neumulticombo.h"
#include "ding.h"
#include <qinputdialog.h>

Neu6Dinge::Neu6Dinge(QWidget *parent)
    : QWizardPage(parent)
{
    setupUi(this);
    fw = new Bogen(this);
    ruestung->addItem(fl("Ohne Rstung - OR"));
    ruestung->addItem(fl("Textilrstung - TR"));
    ruestung->addItem(fl("Lederrstung - LR"));
    ruestung->addItem(fl("Kettenrstung - KR"));
    waffen->addItem("1");
    waffen->addItem("2");
    waffen->addItem("3");
    waffen->addItem("4");
}

void Neu6Dinge::updatePicks() {
    waehlbar->clear();
    if (gewaehlt->count() > waffen->currentIndex() || wizard() == NULL)
        return;
    LernList lernbar = FIGUR->lernbar(WAFFE, LK_NONE);
    lernbar.sort(LES_STOFFE);
    QStringList gelernt;
    QStringList wl;
    for(int i = 0; i < gewaehlt->count(); i++)
        gelernt.append(gewaehlt->item(i)->text());
    foreach(Lernstoff* l, lernbar) {
        QString w = l->property("Ding").toString().split(',')[0];
        if (!Dinge::d()->dingNamen().contains(w) || gelernt.contains(w))
            continue;
        wl.append(w);
    }
    wl.removeDuplicates();
    waehlbar->addItems(wl);
}

void Neu6Dinge::initializePage() {
    QWizardPage::initializePage();
    FIGUR->dinge.clear();
    fw->update(FIGUR);
    geld->setText("80");
    int i;
    QString r = FIGUR->klasse()->property("Startruestung").toString();
    for(i = 0; i < ruestung->count(); i++)
        if (ruestung->itemText(i).contains(r))
            break;
    if (i < ruestung->count())
        ruestung->setCurrentIndex(i);
    i = FIGUR->klasse()->property("Startwaffen").toInt() - 1;
    if (i > -1 && i < waffen->count())
        waffen->setCurrentIndex(i);
    gewaehlt->clear();
    updatePicks();

    // die Spezialwaffen-Combobox neu basteln (es koennte ja ein Krieger sein, bzw. gewesen sein)
    int spezRow, spezCol, spezRowspan, spezColspan;
    gridLayout->getItemPosition(gridLayout->indexOf(spezialisierung), &spezRow, &spezCol, &spezRowspan, &spezColspan);
    QSizePolicy spezPol = spezialisierung->sizePolicy();
    delete spezialisierung;
    int maxSpez = FIGUR->klasse()->property("Spezial").toString().split(',')[0].toInt();
    if (maxSpez > 1) {      // Multi-Select-Combobox (ueber die restlichen Spalten des Grids)
        spezialisierung = new NeuMultiCombo(maxSpez, QModelIndex(), this);
        gridLayout->addWidget(spezialisierung, spezRow, spezCol, spezRowspan, gridLayout->columnCount() - spezCol);
        label_spez->setText("Spezialwaffen");
    } else {                // Default-Combobox (nur eine Spalte breit)
        spezialisierung = new QComboBox(this);
        gridLayout->addWidget(spezialisierung, spezRow, spezCol, spezRowspan, 1);
        label_spez->setText("Spezialwaffe");
    }
    spezialisierung->setObjectName("spezialisierung");
    spezialisierung->setSizePolicy(spezPol);

    // Spezialwaffe befuellen
    spezialisierung->clear();
    spezialisierung->setEnabled(FIGUR->klasse()->property("Spezial").isValid());
    if (spezialisierung->isEnabled()) {
        QStringList spez = FIGUR->klasse()->property("Spezial").toString().split(',');
        spezialisierung->setEnabled(spez.count() == 2 && maxSpez != 0 && spez[1] == "Waffe");
        if (spezialisierung->isEnabled()) {
            spez.clear();
            LernList ll = FIGUR->lernbar(WAFFE, LK_NONE);
            ll.sort(LES_STOFFE);
            foreach(const Lernstoff* l, ll)
                if (l->property("Kategorie").toString() != "Verteidigung") {
                    QString d = l->property("Ding").toString().split(',')[0];
                    if (Dinge::d()->dingNamen().contains(d))
                        spez.append(d);
                    else
                        spez.append(l->name());
                }
            spez.removeDuplicates();
            foreach(QString s, spez)
                if (maxSpez > 1)
                    qobject_cast<NeuMultiCombo*>(spezialisierung)->addItem(s);     // cast noetig da QComboBox::addItem nicht virtuell
                else
                    spezialisierung->addItem(s);
        }
    }
}

void Neu6Dinge::on_waehle_clicked() {
    if (waehlbar->currentItem() == NULL)
        return;
    gewaehlt->addItem(waehlbar->currentItem()->text());
    updatePicks();
}

void Neu6Dinge::on_entferne_clicked() {
    if (gewaehlt->currentItem() == NULL)
        return;
    gewaehlt->takeItem(gewaehlt->currentRow());
    updatePicks();
}

void Neu6Dinge::on_waffen_currentIndexChanged(int index) {
    if (index < 0)
        return;
    while (gewaehlt->count() > index + 1)
        gewaehlt->takeItem(gewaehlt->count() - 1);
    updatePicks();
}

bool Neu6Dinge::validatePage() {
    if (spezialisierung->isEnabled())
        FIGUR->setWidgetValue("spezialisierung", spezialisierung->currentText());
    FIGUR->dinge.clear();
    FIGUR->guthaben.clear();
    if (!ruestung->currentText().contains("OR"))
        FIGUR->dinge.append(Dinge::d(ruestung->currentText()));
    Guthaben g;
    g.setGold(geld->text().toInt());
    FIGUR->guthaben.clear();
    FIGUR->guthaben.append(g);
    for (int i = 0; i < gewaehlt->count(); i++) {
        Ding d = Dinge::d(gewaehlt->item(i)->text());
        FIGUR->dinge.append(d);
        if (d.gruppe().contains("Fern") && !d.gruppe().contains("Wurf")) {  // Munition fuer Fernwaffen verschenken
            QString s = d.name();
            if (s.contains("rmbrust") || s.contains("khallanta")) {
                FIGUR->dinge.addDing(fl("Kcher (30 Bolzen)"));
                FIGUR->dinge.addDing("30 Armbrustbolzen");
            } else if (s.contains("ogen")) {
                FIGUR->dinge.addDing(fl("Kcher (30 Pfeile)"));
                FIGUR->dinge.addDing("30 Pfeile");
            } else if (s == "Blasrohr")
                FIGUR->dinge.addDing("30 Blasrohrnadeln");
            else if (s == "Schleuder") {
                FIGUR->dinge.addDing(fl("Kcher (30 Bleikugeln)"));
                FIGUR->dinge.addDing("30 Bleikugeln");
            }
        }
    }
    foreach(Lernstoff* l, FIGUR->gelerntList)
        if (l->property("Besitz").isValid()) {
            QString b = l->property("Besitz").toString();
            if (!Dinge::d()->dingNamen().contains(b))
                b = l->zusaetze()[l->zusatz()];
            if (Dinge::d()->dingNamen().contains(b))
                FIGUR->dinge.addDing(b);
        }
    if (FIGUR->klasse()->name() == "Ba") {
        QStringList il;
        foreach(Ding d, FIGUR->dinge)
            if (d.gruppe() == "Instrumente")
                il.append(d.name());
        Q_ASSERT(il.length() > 0);
        if (il.length() > 1)
            il[0] = QInputDialog::getItem(NULL, fl("Ausrstung festlegen"), fl("Magisches Instrument auswhlen:"), il, 0);
        for(int i = 0; i < FIGUR->dinge.count(); i++)
            if (FIGUR->dinge[i].name() == il[0])
                FIGUR->dinge[i].setDesc("magisch");
    }
    return QWizardPage::validatePage();
}