#ifndef NEUWIZARD_H
#define NEUWIZARD_H

#include <QWizard>
#include <qpainter.h>
#include "ui_neuwizard.h"

#include "figur.h"

// Makros um die globalen Variablen des Wizards von den WizardPages einfacher zu erreichen
#define FIGUR  qobject_cast<NeuWizard*>(wizard())->figur()
#define SPARLE qobject_cast<NeuWizard*>(wizard())->sparLE

class NeuWizard : public QWizard, public Ui::NeuWizard
{
    Q_OBJECT

public:
    NeuWizard(Figur** f, QWidget *parent = 0);
    ~NeuWizard();

    void addSeiten(const AssocList& fGruppen);   // die Liste von Fertigketisgruppen in neue Wizard-Pages umwandeln

    void paintEvent(QPaintEvent *) {    // damit der weisse Hintergrund funktioniert (Qt-spezial)
        QStyleOption opt;
        opt.init(this);
        QPainter p(this);
        style()->drawPrimitive(QStyle::PE_Widget, &opt, &p, this);
    }

    int                 sparLE;         // gesparte LE (max 1 pro Gruppe)

public slots:
    int     nextId() const;
    void    initializePage(int id);
    void    cleanupPage(int id);
    void    accept();
    Figur*  figur() const;              // Figur die zur aktuellen Page gehoert

private:
    int                 berufId;
    Figur*              actFigur;       // Zeiger auf die aktuelle Figur
    Figur**             oriFigur;       // Zeiger auf den original-Figurenpointer
    QMap<int, Figur*>   figuren;        // speichert den Figurenzustand vor jeder Wizardpage
};

#endif // NEUWIZARD_H
